package de.vanitasvitae.imi.codes.input;

/**
 * Exception which gets thrown when the user-provided input arguments are not valid.
 */
public class InvalidOptionException extends Exception {

    private static final long serialVersionUID = 1L;

    /**
     * Create a new {@link InvalidOptionException}. The message MUST be human readable, as it will get printed to the
     * CLI.
     * @param message human readable error message.
     */
    public InvalidOptionException(String message) {
        super(message);
    }

    /**
     * Create a new {@link InvalidOptionException}. The message MUST be human readable, as it will get printed to the
     * CLI.
     * @param message human readable error message.
     * @param cause cause of the exception.
     */
    public InvalidOptionException(String message, Throwable cause) {
        super(message, cause);
    }
}
