package de.vanitasvitae.imi.codes.persistence;

import java.util.HashMap;
import java.util.Map;

import de.vanitasvitae.imi.codes.types.StudyNumber;

/**
 * Simple implementation of the {@link Repository} interface.
 * Use this only for testing purposes, as no values are persisted.
 */
public class SimpleTestRepository implements Repository {

    private final Map<StudyNumber, Integer> sampleCodes = new HashMap<>();

    @Override
    public int getNextSampleCode(StudyNumber studyNumber) {
        Integer sampleCode = sampleCodes.get(studyNumber);

        return sampleCode != null ? sampleCode : 0;
    }

    @Override
    public void setNextSampleCode(StudyNumber studyNumber, int sampleCode) {
        sampleCodes.put(studyNumber, sampleCode);
    }
}
